/*==================================================================
  ==================================================================
  ==	XMusic -- An Interactive Interface to Csound		  ==
  ==       Copyright (C) 1988 by George D. Drapeau                ==
  ==                  All Rights Reserved                         ==
  ==================================================================
  ==================================================================
*/
/* $Log:	inputWin.c,v $
 * Revision 1.2  89/08/06  18:13:06  drapeau
 * Cleaned up the code for the first X11 release.
 *  */

#include <stdio.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Dialog.h>
#include "defs.h"
#include "externs.h"
#include <string.h>

void CreateInputWindow(label,value,callback,callbackData)
     String		label,value;
     XtCallbackProc	callback;
     char		*callbackData;
{
  Window		rootReturn,childReturn;
  int			rootX,rootY,x,y;
  unsigned int		maskReturn;
  Arg			argList[2];

  XQueryPointer(dpy,musicWin,					    /* Find out where the user clicked the mouse */
		&rootReturn,&childReturn,
		&rootX,&rootY,
		&x,&y,
		&maskReturn);
  XtSetArg(argList[0],XtNx,rootX);
  XtSetArg(argList[1],XtNy,rootY);
  inputWidget		= XtCreatePopupShell("input",		    /* Create a Popup shell for the Input window */
					     transientShellWidgetClass,
					     topLevelShell,
					     argList,XtNumber(argList));
  XtSetArg(argList[0],XtNlabel,label);
  XtSetArg(argList[1],XtNvalue,value);
  inputDialogWidget 	= XtCreateManagedWidget("inputDialog",	    /* Create a Dialog widget to prompt for input */
						dialogWidgetClass,
					        inputWidget,
						argList,2);
  XawDialogAddButton(inputDialogWidget,"enter",AcceptInput,NULL);   /* Create a 'Enter' command for the Input Window */
  XtAddCallback(XtNameToWidget(inputDialogWidget,"enter"),	    /* Add the callback supplied as argument to the... */
		XtNcallback,callback,callbackData);		    /* ...Enter button's callback list */
  XawDialogAddButton(inputDialogWidget,"cancel",CancelInput,NULL);  /* Create a 'Cancel' command for the Input Window */
  XtRealizeWidget(inputWidget);
  XtPopup(inputWidget,XtGrabNone);
}								    /* end function CreateInputWindow */
